package com.pixelized.shared.lwa.model.campaign

data class Campaign(
    val characters: Set<String>,
    val npcs: Set<String>,
    val scene: Scene,
    val options: Options,
) {
    val instances = characters + npcs

    data class Scene(
        val name: String,
    ) {
        companion object {
            fun empty() = Scene(
                name = "",
            )
        }
    }

    data class Options(
        val showParty: Boolean,
        val showNpcs: Boolean,
    ) {
        companion object {
            fun empty() = Options(
                showParty = true,
                showNpcs = false,
            )
        }
    }

    companion object {
        fun empty() = Campaign(
            characters = emptySet(),
            npcs = emptySet(),
            scene = Scene.empty(),
            options = Options.empty(),
        )
    }
}